''' Module defining the main data model for QDL '''

from Config import *
 
class QuoteResult:
      ''' Data object that stores from a quote download. '''
      
      # TODO: add low, high, volume

      def __init__(self, symbol, price, datum, name=None,):
            self.symbol = symbol
            self.price = price
            self.datum = datum
            self.name = name
          
        
      def toString(self):
            ''' Takes teh outformat and nameformat strings from Config.py
            and returns the string with the placeholders replaced by the
            actual values. '''
            qstr = outformat
            qstr = qstr.replace("$s",self.symbol)
            pStr = str(self.price)
            pStr = pStr.replace(".",numsepformat)
            qstr = qstr.replace("$p",pStr)
            qstr = qstr.replace("$d",self.datum.strftime(dateformat))
            if self.name:
                  namestr = nameformat.replace("$n",  self.name)
                  qstr = qstr + namestr
            return qstr

        
class QuoteInput:
      ''' Data object that stores input information for a quote download. This
      included driver, source, name and the symbol to download. '''
      
      def __init__(self):
              # Variables for the application
              self.driver = defaultdriver
              self.source = defaultsource
              self.name = None
              self.symbol = None
              self.debug = 0
              self.debugAll = 0


class SourceItem:
      ''' Data object that stores information about an individual source configuration. '''
      
      # TODO: add high, low, volume
      
      def __init__(self, name=None, url=None, symbol=None, price=None, date=None, dateformat=None):
            self.name = name
            self.url = url
            self.symbol = symbol
            self.price = price
            self.date = date
            self.dateformat = dateformat
