''' Module providing the relevant functionality for the pfq driver '''

import os

from Config import *
from core.Model import *
from core import Parser
from PfqSources import *


class PfqQuoteService:
      ''' Class providing relevant functionality for the kmm driver'''
    

      def __getPfqSource(self):
            ''' Returns a SourceItem object with the required regexps
            for the PFQ driver. '''
            # a source item definint the financequote.pl syntax
            src = SourceItem()
            src.symbol = "\"([^,\"]*)\",.*"
            src.price = "[^,]*,[^,]*,\"([^\"]*)\""
            src.date = "[^,]*,([^,]*),.*"
            src.dateformat =  '"%Y-0%m-0%d"'
            return src

      def getQuote(self, source, symbol,  debug=0,  debugAll=0):
            ''' Returns quote information from a given source for a given symbol 
            as a QuoteResult object '''
            sources = PfqSources()
            if source not in sources.getSourceNames():
                  print "Invalid source name %s" % source
                  return

            # execute perl finance quote, redirect output to here, 
            execStr = perlpath + " " + perlfinance + " "  + source + " "  + symbol
            if debug:
                  print "Debug ExecStr: " + execStr

            quoteString = os.popen(execStr).read()
            if debugAll:
                  print "Debug Page: " + quoteString

            sourceItem = self.__getPfqSource()
            price = Parser.parsePrice(sourceItem, quoteString,  debug)
            datum = Parser.parseDate(sourceItem, quoteString,  debug)

            quote = QuoteResult(symbol, price, datum)            
            return quote
          
        
